/*
oop_ex103.cpp
Virtual Functions
*/

#include <iostream>

using namespace std;

class shape
{
public:
	virtual void move(int x, int y) { cout << "do move shape by (" << x << ", " << y << ")" << endl; }

	virtual void draw() { cout << "do draw shape" << endl; } // declare draw as a virtual function
	//void draw(){ cout<< "do draw shape"<<endl; } // draw as a normal member function
};


class circle : public shape
{
public:
	void move(int x, int y) { cout << "do move circle by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw circle" << endl; }
};


class triangle : public shape
{
public:
	void move(int x, int y) { cout << "do move triangle by (" << x << ", " << y << ")" << endl; }

	//void draw(){ cout<<"do draw triangle"<<endl; }	
	virtual void draw() { cout << "do draw triangle" << endl; }
};


class square : public triangle
{
public:
	void move(int x, int y) { cout << "do move square by (" << x << ", " << y << ")" << endl; }
	void draw() { cout << "do draw square" << endl; }
};



void main()
{
	shape sh;
	circle ci;
	triangle tr;
	square sq;

	shape* ptr[4] = { &sh, &ci, &tr, &sq };

	for (int i = 0; i<4; i++)
		ptr[i]->draw();

	for (int i = 0; i<4; i++)
		ptr[i]->move(i, i);

	cout << endl;
	triangle* t = &sq;
	t->draw();

	t->shape::draw();	//can call base class function through derived class's pointer
	
	system("pause");
}